# -*- coding: utf-8 -*-
"""
Spyder Editor

This is a temporary script file.
"""

import pandas as pd
import numpy as np
import lxml.etree as ET
import subprocess
from shutil import copyfile

"""

USER DEFINED

"""

input_file = "test.liml"
variable_map = {"%%FORCE1%%" : 2, "%%FORCE2%%": 3, "%%outputcsv%%": "output.csv", "%%saveaftersolve%%": "results"}
output_file = "pythonoutput.liml"

"""

Functions

"""
def duplicateFile(src = input_file, dst= output_file):
    copyfile(src, dst)

def inplace_change(filename, old_string, new_string):
    # Function to replace strings in file
    
    # Safely read the input filename using 'with'
    with open(filename) as f:
        s = f.read()
        if old_string not in s:
            print('"{old_string}" not found in {filename}.'.format(**locals()))
            return

    # Safely write the changed content, if found in the file
    with open(filename, 'w') as f:
        print('Changing "{old_string}" to "{new_string}" in {filename}'.format(**locals()))
        s = s.replace(old_string, new_string)
        f.write(s)

def setupAnalysis(filename = output_file, var_dict = variable_map):
    for var in var_dict:
        inplace_change(filename, var, str(var_dict[var]))

def runAnalysis(filename = output_file):
    subprocess.check_output(["C:\Program Files\Mecway\Mecway13\mecway.exe", filename, "solve"], shell=True)    
    
if __name__ == "__main__":
    for force1 in np.linspace(2, 20, 2):
        for force2 in np.linspace(100, 200, 2):
            variable_map["%%FORCE1%%"] = force1
            variable_map["%%FORCE2%%"] = force2
            variable_map["%%outputcsv%%"] = "f1-%s-f2-%s.csv" %(force1, force2)
            variable_map["%%saveaftersolve%%"] = "f1-%s-f2-%s" %(force1, force2)
            duplicateFile(input_file, output_file)
            setupAnalysis(output_file, variable_map)
            runAnalysis(output_file)